module RocketGate
  class Authorization
    attr_accessor :auth_code, :avs_response, :cvv_response, :reason_code,
                  :approved_amount, :approved_currency, :customer_id, :card_hash,
                  :card_expiration, :card_last_four, :card_type, :card_description,
                  :card_country, :issuer_network, :issuer_url, :issuer_name,
                  :issuer_phone, :reference_id

    def avs_ok?
      if RocketGate.configuration.require_avs
        RocketGate::ResponseCode::AVS_SUCCESSES.include?(avs_response)
      else
        true
      end
    end

    def cvv_ok?
      if RocketGate.configuration.require_cvv
        RocketGate::ResponseCode::CVV_SUCCESSES.include?(cvv_response)
      else
        true
      end
    end

    def declined?
      !success?
    end

    def success?
      avs_ok? && cvv_ok? && reason_code == :success
    end
  end
end
