require 'net/http'

module RocketGate
  class Connection
    def initialize(server, port, path)
      @server, @port, @path = server, port, path
      @client               = Net::HTTP.new(server, port)

      @client.open_timeout  = RocketGate.configuration.request_timeout
      @client.read_timeout  = RocketGate.configuration.request_timeout

      if RocketGate.configuration.require_ssl
        @client.use_ssl     = true
        @client.verify_mode = OpenSSL::SSL::VERIFY_NONE
      end
    end

    def make_request!(request_body)
      request          = Net::HTTP::Post.new(@path, {
        'Accept'       => 'text/xml',
        'Content-Type' => 'text/xml',
        'User-Agent'   => "rocketgate-ruby/#{RocketGate::VERSION}"
      })

      request.body     = request_body

      @client.request(request)
    end
  end
end
