module RocketGate
  class Customer
    include Hashable, Validatable

    attr_accessor :id, :first_name, :last_name, :street_address, :city,
                  :postal_code, :state, :country, :email, :username, :ip_address

    validatable :id, :first_name, :last_name

    hashable({
      merchantCustomerID:     :id,
      customerFirstName:      :first_name,
      customerLastName:       :last_name,
      billingAddress:         :street_address,
      billingCity:            :city,
      billingState:           :state,
      billingZipCode:         :postal_code,
      billingCountry:         :country,
      email:                  :email,
      username:               :username,
      ipAddress:              :ip_address
    })

    def initialize(*args)
      @first_name, @last_name, @street_address, @city, @state, @postal_code,
        @country, @email, @username, @ip_address, @id = *args
    end

    def id
      @id ||= SecureRandom.uuid
    end
  end
end
